

*/
#property copyright "ChartSecret.com"
#property link      "www.ChartSecret.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Red

extern int SMA.Period = 20;
extern double Minimal.Slope.ATR = 0.2;
extern int MA.Type = 0;
double G_ibuf_92[];
double G_ibuf_96[];
double G_ibuf_100[];

int init() {
   if (ObjectType("lbl") != 23) ObjectDelete("lbl");
   if (ObjectFind("lbl") == -1) ObjectCreate("lbl", OBJ_LABEL, 0, Time[5], Close[5]);
   ObjectSetText("lbl", "MA Bounce Indicator | ChartSecret.com");
   ObjectSet("lbl", OBJPROP_FONTSIZE, 12);
   ObjectSet("lbl", OBJPROP_XDISTANCE, 5);
   ObjectSet("lbl", OBJPROP_YDISTANCE, 20);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, G_ibuf_92);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, G_ibuf_96);
   SetIndexEmptyValue(1, 0.0);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, G_ibuf_100);
   SetIndexEmptyValue(2, 0.0);
   return (0);
}

int deinit() {
   ObjectDelete("lbl");
   return (0);
}

int start() {
   double Lda_0[4];
   if (ObjectType("lbl") != 23) ObjectDelete("lbl");
   if (ObjectFind("lbl") == -1) ObjectCreate("lbl", OBJ_LABEL, 0, Time[5], Close[5]);
   ObjectSetText("lbl", "MA Bounce Indicator | ChartSecret.com");
   ObjectSet("lbl", OBJPROP_FONTSIZE, 12);
   ObjectSet("lbl", OBJPROP_XDISTANCE, 5);
   ObjectSet("lbl", OBJPROP_YDISTANCE, 20);
   double iatr_4 = iATR(Symbol(), 0, 50, 1);
   for (int index_12 = 0; index_12 < Bars; index_12++) G_ibuf_100[index_12] = 0;
   for (index_12 = 0; index_12 < Bars; index_12++) {
      G_ibuf_92[index_12] = 0.0;
      G_ibuf_96[index_12] = 0.0;
      for (int index_16 = 0; index_16 < 4; index_16++) Lda_0[index_16] = iMA(Symbol(), 0, SMA.Period, 0, MA.Type, PRICE_CLOSE, index_12 + index_16 + 1);
      if (Lda_0[0] > Lda_0[1] && Lda_0[1] > Lda_0[2] && Lda_0[2] > Lda_0[3] && Lda_0[0] - Lda_0[3] > Minimal.Slope.ATR * iatr_4 && Close[index_12] > Lda_0[0] && Close[index_12 +
         1] > Lda_0[0] && Close[index_12 + 2] > Lda_0[1] && Close[index_12 + 3] > Lda_0[2] && Close[index_12 + 4] > Lda_0[3] && Close[index_12 + 5] > Lda_0[3] && High[index_12] > High[index_12 +
         1] && Low[index_12] - iatr_4 / 10.0 < Lda_0[0] || Low[index_12 + 1] - iatr_4 / 10.0 < Lda_0[1] || Low[index_12 + 2] - iatr_4 / 10.0 < Lda_0[2]) {
         G_ibuf_92[index_12] = Low[index_12] - iatr_4 / 2.0;
         G_ibuf_100[index_12] = Low[iLowest(Symbol(), 0, MODE_LOW, 3, index_12 + 1)] - 1.0 * Point;
         G_ibuf_100[index_12 + 1] = G_ibuf_100[index_12];
         G_ibuf_100[index_12 + 2] = G_ibuf_100[index_12];
      }
      if (Lda_0[0] < Lda_0[1] && Lda_0[1] < Lda_0[2] && Lda_0[2] < Lda_0[3] && Lda_0[3] - Lda_0[0] > Minimal.Slope.ATR * iatr_4 && Close[index_12] < Lda_0[0] && Close[index_12 +
         1] < Lda_0[0] && Close[index_12 + 2] < Lda_0[1] && Close[index_12 + 3] < Lda_0[2] && Close[index_12 + 4] < Lda_0[3] && Close[index_12 + 5] < Lda_0[3] && Low[index_12] < Low[index_12 +
         1] && High[index_12] + iatr_4 / 10.0 > Lda_0[0] || High[index_12 + 1] + iatr_4 / 10.0 > Lda_0[1] || High[index_12 + 2] + iatr_4 / 10.0 > Lda_0[2]) {
         G_ibuf_96[index_12] = High[index_12] + iatr_4 / 2.0;
         G_ibuf_100[index_12] = High[iHighest(Symbol(), 0, MODE_HIGH, 3, index_12 + 1)] + 1.0 * Point;
         G_ibuf_100[index_12 + 1] = G_ibuf_100[index_12];
         G_ibuf_100[index_12 + 2] = G_ibuf_100[index_12];
      }
   }
   return (0);
}
